; unlockgo.pb
; by slowmaker
; Runs command line whenever windows session is unlocked
; (i.e. you return to your logon from a fast user switch).
; Idea came from a question on DonationCoder.com forum in
; the developer's board.
;
;
;Release History
;===============
;Release 1      2010 Jan 16
;
#RELEASE_NUM = 1

includePath "\_src\_util.pbi\"
xIncludeFile "_util.pbi"
xIncludeFile "wtsapi32.pbi"

enumeration 100
    #IDI_UNLOCKGO
    #IDI_OFF

    #MNU_UNLOCKGO
        #IDM_EXIT
        #IDM_ABOUT
endEnumeration


#WM_ICONNOTIFY = #WM_USER + 101

Global app_name.s = "UnlockGo"
Global hinstance = GetModuleHandle_(#NULL)

procedure.s strip_prog_name(comline.s)
    define start = 1
    while left(comline, 1) = " " or left(comline, 1) = chr(9)
        start + 1
    wend
    comline = mid(comline, start)
    
    while mid(comline, start, 1) <> " "
        if mid(comline, start, 1) = chr(34)
            start + 1
            while start < len(comline) and mid(comline, start, 1) <> chr(34)
                start + 1
            wend
        endIf
        start + 1
        if start >= len(comline)
            procedureReturn ""
        endIf
    wend
    start + 1

    procedureReturn mid(comline, start)
endProcedure

global command_line.s = strip_prog_name(peekS(GetCommandLine_()))


procedure about()
    define msg.s = app_name + " sends your command line to the system whenever your session unlocks, i.e. when you log back in from a 'fast user switch'."
    msg + chr(10) + chr(10) + "USAGE: " + lCase(app_name) + " <command line you want to execute on unlock>"
    msg + chr(10) + chr(10) + app_name + " is donation-optional freeware, written by slowmaker of http://programmingforfun.net.  See unlockgo.txt for more detail."
    msg + chr(10) + chr(10) + "Also, be sure to check out http://www.donationcoder.com. They are a great bunch of people who have accumulated/created an amazing selection of software. The idea for this program came directly from a forum post in their developers corner."
    MessageBox_(#NULL, msg, app_name + " Release " + str(#RELEASE_NUM), #MB_OK)
endProcedure


if not len(command_line)
    about()
    end 1
endIf


procedure exec(comline.s)
    define si.STARTUPINFO
        si\cb = sizeOf(STARTUPINFO)
        si\wShowWindow = #SW_SHOWNORMAL
    define pi.PROCESS_INFORMATION
    
    define retval = CreateProcess_(#NULL, comline, #NULL, #NULL, #FALSE, 0, #NULL, #NULL, si, pi)

    if retval
        ; don't need the handles, close them to prevent memory leaks
        ; (the created process terminating won't do it).
        CloseHandle_(pi\hThread)
        CloseHandle_(pi\hProcess)
    endIf
    
    procedureReturn retval
endProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Window Message Handlers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Procedure main_callback(hwnd, message, wparam, lparam)
    static nid.NOTIFYICONDATA, current_icon_id
    
    Select message
        Case #WM_ICONNOTIFY
            Select lParam
                Case #WM_LBUTTONUP  ; TOGGLE THE STATE ON/OFF
                    If current_icon_id = #IDI_UNLOCKGO
                        current_icon_id = #IDI_OFF
                    else
                        current_icon_id = #IDI_UNLOCKGO
                    EndIf

                    nid\hIcon = LoadImage_(hinstance, MAKEINTRESOURCE(current_icon_id), #IMAGE_ICON, 16, 16, 0)

                    Shell_NotifyIcon_(#NIM_MODIFY, nid)

                Case #WM_RBUTTONUP  ; OFFER MENU
                    Define point.POINT, hmenu, hsubmenu

                    GetCursorPos_(@point)

                    hmenu = LoadMenu_(hinstance, MAKEINTRESOURCE(#MNU_UNLOCKGO))
                    hsubmenu = GetSubMenu_(hmenu, 0)
                    SetMenuDefaultItem_(hsubmenu, #IDM_ABOUT, #FALSE)

                    SetForegroundWindow_(hwnd)
                    TrackPopupMenu_(hsubmenu, #TPM_LEFTBUTTON|#TPM_RIGHTBUTTON|#TPM_LEFTALIGN, point\x, point\y, 0, hwnd, #NULL)
                    PostMessage_(hwnd, #WM_NULL, 0, 0)
                    DestroyMenu_(hmenu)
                Case #WM_LBUTTONDBLCLK
                    ; DO NOTHING
            EndSelect
        Case #WM_COMMAND
            Select LOWORD(wParam)
                Case #IDM_EXIT
                    PostMessage_(hwnd, #WM_CLOSE, 0, 0)
                Case #IDM_ABOUT
                    about()
            endSelect
            procedureReturn 0
        Case #WM_CREATE
            ; set up tray icon
            current_icon_id = #IDI_UNLOCKGO
            with nid
                \cbSize = SizeOf(NOTIFYICONDATA)
                \uID = current_icon_id  ; doesn't matter unless you have multiple simultaneous icons
                \hIcon = LoadImage_(hinstance, MAKEINTRESOURCE(current_icon_id), #IMAGE_ICON, 16, 16, 0)
                \hwnd = hwnd
                \uFlags = #NIF_ICON|#NIF_MESSAGE|#NIF_TIP
                \uCallbackMessage = #WM_ICONNOTIFY
                PokeS(@\szTip, app_name)
            endWith
                

            Shell_NotifyIcon_(#NIM_ADD, nid)

            ; get user switch notifications
            WTSRegisterSessionNotification_(hwnd, #NOTIFY_FOR_THIS_SESSION)
            procedureReturn 0
        Case #WM_WTSSESSION_CHANGE
            if current_icon_id = #IDI_UNLOCKGO
                if wparam = #WTS_SESSION_UNLOCK
                    if not exec(command_line)
                        MessageBox_(hwnd, "Could not execute command:" + chr(10) + command_line, app_name, #MB_ICONERROR)
                    endIf
                endIf
            endIf
            
            procedureReturn 0
        Case #WM_DESTROY
            Shell_NotifyIcon_(#NIM_DELETE, nid)
            WTSUnRegisterSessionNotification_(hwnd)
            PostQuitMessage_(0)
            procedureReturn 0
    EndSelect

    ProcedureReturn DefWindowProc_(hwnd, message, wparam, lparam)
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
procedure main()
    Define wclass.WNDCLASS
        With wclass
                \lpfnWndProc = @main_callback()
                \hinstance = hinstance
                \lpszClassName = @app_name
                \style = #CS_HREDRAW | #CS_VREDRAW
                \hicon = LoadIcon_(hinstance, MAKEINTRESOURCE(#IDI_UNLOCKGO))
                \hcursor = LoadCursor_(0, #IDC_ARROW)
                \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(wclass)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwnd = CreateWindowEx_(#NULL,app_name,#NULL,#WS_OVERLAPPEDWINDOW,0,0,0,0,#NULL, #NULL,hinstance,#NULL)
        If Not hwnd
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

    procedureReturn msg\wparam
endProcedure

End main()